/* Stream client */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <time.h>

#define PORT 10000
#define MAXDATASIZE 100 /* max number of bytes to get at once */

int main(int argc, char *argv[])
{
    int sockfd, numbytes;
    char buffer[MAXDATASIZE];
    struct hostent *he;
    struct sockaddr_in their_addr; /* connector’s addr infor */

    if (argc != 2) {
        fprintf(stderr,"usage: client hostname\n");
        exit(1);
    }

    if ((he=gethostbyname(argv[1])) == NULL) { /* get host info */
        herror("gethostbyname");
        exit(1);
    }

    if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
        perror("socket");
        exit(1);
    }

    their_addr.sin_family = AF_INET; /* host byte order */
    their_addr.sin_port = htons(PORT); /* short, network byte order */
    their_addr.sin_addr = *((struct in_addr *)he->h_addr);
    memset(&(their_addr.sin_zero), '\0', 8); /* zero rest of the struct */

    if (connect(sockfd, (struct sockaddr *)&their_addr,
                sizeof(struct sockaddr)) == -1) {
        perror("connect");
        exit(1);
    }

    char msg[MAXDATASIZE] = "Hello packet!";
    printf("== %i == client: sending from the client: %s\n", time(0), msg);

    if (send(sockfd, msg, 14, 0) == -1) {
        perror("send");
        exit(1);
    }

    if ((numbytes=recv(sockfd, buffer, MAXDATASIZE-1, 0)) == -1) {
        perror("recv");
        exit(1);
    }

    buffer[numbytes] = '\0';
    printf("== %i == client: received from server: %s\n", time(0), buffer);

    close(sockfd);

    return 0;
}
